from __future__ import absolute_import
from qgis._core import QgsField
from .functions import type_py2gpkg

class Comp3dPoint:
    def __init__(self, name, isStation, dico, centered=False):
        self.name = name
        self.is_station = isStation
        self.centered = centered
        self.__dict__.update(dico)

    def get_x(self):
        if hasattr(self, 'coord_compensated_georef'):
            return self.coord_compensated_georef[0]
        elif hasattr(self, 'coord_compensated_stereographic'):
            return self.coord_compensated_stereographic[0]
        else:
            return self.coord_read[0]

    def get_y(self):
        if hasattr(self, 'coord_compensated_georef'):
            return self.coord_compensated_georef[1]
        elif hasattr(self, 'coord_compensated_stereographic'):
            return self.coord_compensated_stereographic[1]
        else:
            return self.coord_read[1]

    def get_h(self):
        if hasattr(self, 'coord_compensated_georef'):
            return self.coord_compensated_georef[2]
        elif hasattr(self, 'coord_compensated_stereographic'):
            return self.coord_compensated_stereographic[2]
        else:
            return self.coord_read[2]

    def __str__(self):
        values = []
        for a in self.__dict__.values():
            values.append(a)
        return ', '.join(map(str, values))

    def get_attributes(self):
        return list(self.__dict__.keys())

    def get_qgis_fields(self):
        lst_qgis_fields = []
        for att in dir(self):
            if not att.startswith('__') and not callable(getattr(self, att)):
                pytype = type(getattr(self, att))
                # print(pytype, getattr(self, att), att)
                lst_qgis_fields.append(QgsField(att, type_py2gpkg(pytype)))
                # lst_qgis_fields.append(QgsField(att))
        return lst_qgis_fields